"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.definition = void 0;
exports.definition = {
    id: '3evils',
    name: '3evils',
    description: '3evils is a Private Torrent Tracker for MOVIES / TV / GENERAL',
    language: 'en-EN',
    type: 'private',
    encoding: 'UTF-8',
    links: ['https://www.3evils.net/'],
    legacylinks: ['https://www.3evils.com/', 'https://the-unknown.xyz/'],
    caps: {
        categorymappings: [
            { id: '73', cat: 'PC', desc: 'Appz/Linux' },
            { id: '42', cat: 'PC/Mac', desc: 'Appz/Mac' },
            { id: '43', cat: 'PC/0day', desc: 'Appz/Windows' },
            { id: '65', cat: 'Books/Ebook', desc: 'Books' },
            { id: '80', cat: 'Console/NDS', desc: 'Games/Nintendo' },
            { id: '78', cat: 'Console/PS4', desc: 'Games/PS4' },
            { id: '77', cat: 'PC/Games', desc: 'Games/Windows' },
            { id: '79', cat: 'Console/Xbox', desc: 'Games/XBOX' },
            { id: '13', cat: 'Movies/3D', desc: 'Movies/3D' },
            { id: '71', cat: 'Movies/UHD', desc: 'Movies/4K' },
            { id: '72', cat: 'Movies/BluRay', desc: 'Movies/Blu-Ray' },
            { id: '12', cat: 'Movies/DVD', desc: 'Movies/DVD-R' },
            { id: '14', cat: 'Movies', desc: 'Movies/Packs' },
            { id: '70', cat: 'Movies/SD', desc: 'Movies/Screeners & Cams' },
            { id: '16', cat: 'Movies/HD', desc: 'Movies/x264' },
            { id: '17', cat: 'Movies/HD', desc: 'Movies/X265' },
            { id: '11', cat: 'Movies/SD', desc: 'Movies/XVID' },
            { id: '74', cat: 'Audio/Lossless', desc: 'Music/FLAC' },
            { id: '33', cat: 'Audio/MP3', desc: 'Music/MP3' },
            { id: '32', cat: 'Audio', desc: 'Music/Packs' },
            { id: '75', cat: 'Audio/Video', desc: 'Music/Videos' },
            { id: '6', cat: 'TV', desc: 'TV/Packs' },
            { id: '3', cat: 'TV/HD', desc: 'TV/x264' },
            { id: '4', cat: 'TV/HD', desc: 'TV/x265' },
            { id: '8', cat: 'TV/SD', desc: 'TV/Xvid' },
        ],
        modes: {
            search: ['q'],
            'tv-search': ['q', 'season', 'ep'],
            'movie-search': ['q'],
            'music-search': ['q'],
            'book-search': ['q'],
        },
    },
    settings: [
        { name: 'username', type: 'text', label: 'Username' },
        { name: 'password', type: 'password', label: 'Password' },
        {
            name: 'freeleech',
            type: 'checkbox',
            label: 'Search freeleech only',
            default: false,
        },
        {
            name: 'sort',
            type: 'select',
            label: 'Sort requested from site',
            default: 4,
            options: { '1': 'title', '4': 'created', '5': 'size', '7': 'seeders' },
        },
        {
            name: 'type',
            type: 'select',
            label: 'Order requested from site',
            default: 'desc',
            options: { desc: 'desc', asc: 'asc' },
        },
        {
            name: 'info_tpp',
            type: 'info',
            label: 'Results Per Page',
            default: 'For best results, change the <b>Torrents per page:</b> setting to <b>100</b> on your account profile. The default is <i>15</i>.',
        },
    ],
    login: {
        path: 'login.php',
        method: 'form',
        form: 'form[action="takelogin.php"]',
        inputs: {
            username: '{{ .Config.username }}',
            password: '{{ .Config.password }}',
            use_ssl: 1,
            perm_ssl: '',
        },
        error: [{ selector: 'div.callout:contains("Login failed!")' }],
        test: { path: '/', selector: 'a[href*="/logout.php?hash_please="]' },
    },
    search: {
        paths: [{ path: 'browse.php' }],
        inputs: {
            $raw: '{{ range .Categories }}c{{.}}=1&{{end}}',
            search: '{{ .Keywords }}',
            searchin: 'title',
            incldead: 1,
            only_free: '{{ if .Config.freeleech }}1{{ else }}{{ end }}',
            sort: '{{ .Config.sort }}',
            type: '{{ .Config.type }}',
        },
        rows: {
            selector: 'table.unstriped tbody tr:has(a[href^="download.php?torrent="])',
            filters: [{ name: 'andmatch' }],
        },
        fields: {
            category: {
                selector: 'a[href^="browse.php?cat="]',
                attribute: 'href',
                filters: [{ name: 'querystring', args: 'cat' }],
            },
            title: {
                selector: 'a[href^="details.php?id="]',
                attribute: 'onmouseover',
                filters: [{ name: 'regexp', args: "Tip\\('<b>(.*?)</b>" }],
            },
            details: {
                selector: 'a[href^="details.php?id="]',
                attribute: 'href',
            },
            download: {
                selector: 'a[href^="download.php?torrent="]',
                attribute: 'href',
            },
            poster: {
                selector: 'a[href^="details.php?id="]',
                attribute: 'onmouseover',
                filters: [
                    { name: 'regexp', args: 'src="(.*?)"' },
                    { name: 'replace', args: ['./pic/noposter.png', ''] },
                ],
            },
            files: { selector: 'td[data-label="Files"]' },
            date: {
                optional: true,
                selector: 'td[data-label="Added"]:not(:contains("day"))',
                filters: [
                    { name: 'append', args: ' +00:00' },
                    { name: 'dateparse', args: 'Jan 2 2006 03:04 PM -07:00' },
                ],
            },
            size: { selector: 'td[data-label="Size"]' },
            grabs: {
                selector: 'td[data-label="Snatched"]',
                filters: [{ name: 'regexp', args: '(\\d+)' }],
            },
            seeders: { selector: 'td[data-label="Seeders"]' },
            leechers: { selector: 'td[data-label="Leechers"]' },
            downloadvolumefactor: {
                case: { 'a.info:contains("[FREE]")': 0, '*': 1 },
            },
            uploadvolumefactor: { case: { '*': 1 } },
            minimumratio: { text: 1 },
            minimumseedtime: { text: 172800 },
        },
    },
    source: 'jackett',
};
